// Process SpectatorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Process Spectator.h"
#include "Process SpectatorDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CAboutDlg dialog used for App About

// Add CLR libraries
#using <system.dll>
#using <mscorlib.dll>

// Use this namespace
using namespace System;

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CProcessSpectatorDlg dialog
CProcessSpectatorDlg::CProcessSpectatorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CProcessSpectatorDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CProcessSpectatorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CProcessSpectatorDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_TIMER()
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCLOSE, OnBnClickedClose)
	ON_BN_CLICKED(IDKILL, OnBnClickedKill)
	ON_NOTIFY(LVN_ITEMCHANGED, IDL_PROCESS, OnLvnItemchangedProcess)
END_MESSAGE_MAP()


// CProcessSpectatorDlg message handlers
BOOL CProcessSpectatorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Set process list control 
	pProcess=(CListCtrl*)GetDlgItem(IDL_PROCESS);
	pProcess->InsertColumn(0,"Process Name",LVCFMT_LEFT,128);
	pProcess->InsertColumn(1,"PID",LVCFMT_RIGHT,40);
	pProcess->InsertColumn(2,"Threads",LVCFMT_RIGHT,55);
	pProcess->InsertColumn(3,"Modules",LVCFMT_RIGHT,55);
	pProcess->InsertColumn(4,"Handles",LVCFMT_RIGHT,55);
	pProcess->InsertColumn(5,"CPU Time",LVCFMT_RIGHT,64);
	pProcess->InsertColumn(6,"Window Title",0,140);
	pProcess->SetExtendedStyle( pProcess->GetExtendedStyle()| LVS_EX_FULLROWSELECT );

	// Set modules list control 
	pModules=(CListCtrl*)GetDlgItem(IDL_MODULES);
	pModules->InsertColumn(0,"Module Name",LVCFMT_LEFT,92);
	pModules->InsertColumn(1,"Version",LVCFMT_LEFT,80);
	pModules->InsertColumn(2,"Base Address",LVCFMT_RIGHT,80);
	pModules->InsertColumn(3,"Mem Load",LVCFMT_RIGHT,80);
	pModules->SetExtendedStyle(pModules->GetExtendedStyle()| LVS_EX_FULLROWSELECT  );

	// Set threads list control 
	pThreads=(CListCtrl*)GetDlgItem(IDL_THREADS);
	pThreads->InsertColumn(0,"ID",LVCFMT_LEFT,32);
	pThreads->InsertColumn(1,"Priority",LVCFMT_RIGHT,50);
	pThreads->InsertColumn(2,"CPU Time",LVCFMT_RIGHT,66);
	pThreads->InsertColumn(3,"Base Address",LVCFMT_RIGHT,80);
	pThreads->SetExtendedStyle(pThreads->GetExtendedStyle()| LVS_EX_FULLROWSELECT );

	SetTimer(1234,30000,0);	// Update on every 30 seconds (Changing this value at runtime will be in next update)

	RefreshList();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CProcessSpectatorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CProcessSpectatorDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CProcessSpectatorDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

// Simple routine to convert managed code 'String'
// to unmanaged code 'const char*' 
LPCSTR FromMCtoUCStr(String *pStr)
{
	static char str[128];
	for(int i=0;i<pStr->Length;i++)
	{
		// Typecasting this manner can be mistake
		// and also ignores UNICODE strings
		str[i]=(char)pStr->Chars[i];
	}
	str[i]=0;
	return str;
}

void CProcessSpectatorDlg::OnTimer(UINT nIDEvent)
{
	CDialog::OnTimer(nIDEvent);
	RefreshList();
}

void CProcessSpectatorDlg::OnBnClickedOk()	// In place of OnOK
{
	RefreshList();
}

void CProcessSpectatorDlg::OnBnClickedClose()
{
	int nSel=pProcess->GetSelectionMark()	;
	/*if(nSel==-1)
	{
		AfxMessageBox("Please select a process image first.");
		pProcess->SetFocus();
		return;
	}*/

	try
	{
		Diagnostics::Process *g=Diagnostics::Process::GetProcessById(ProcessID[nSel]);
		g->CloseMainWindow();
	}

	catch(ArgumentException *)
	{
		AfxMessageBox("That process has already been terminated.\n(view may not be refreshed to update it)",MB_ICONEXCLAMATION);
	}
	RefreshList();
}

/*From MSDN: 
	Process identifiers can be reused by the system. The Id property value is unique 
	only while the associated process is running. After the process has terminated, 
	the system can reuse the Id property value for an unrelated process.

We are storing process IDs in CDWordArray for later reference. Initially fine. 
What about following case holds:
	* A process with ID 640 starts
	* Our view is refresh for same - ID 640 is stored in array
	* Process 640 is terminated (Our view is NOT refresh for the same)
	* Time elapses, processes come and die and later another
	    process of ID 640 enters the system (See above that this is possible)
	* User needs to Close/Kill the process - AND AN INCORRECT PROCESS IS TERMINATED!!!

What could be done:
	* Use timestamp for each process and inform user if incorrect
	  process is being terminated

But this may also raise problem if
	* User changes system time
	* System runs for more than one days

For this we may also store window title#, handle, handle count, main module
and other heuristics. Then what about memory load. Please discuss this 
problem with me on vv_ajay@hotmail.com 

( # Window title may also be changed by program.)
*/
void CProcessSpectatorDlg::RefreshList(void)
{
	pProcess->DeleteAllItems();

	Diagnostics::Process *p[]=Diagnostics::Process::GetProcesses();
	
	char s[60]; 
	ProcessID.RemoveAll();
	for(int n=p->GetLength(0),i=0;		i<n;		i++)
	{
		ProcessID.Add(p[i]->Id);

		LPCSTR lp=FromMCtoUCStr(p[i]->ProcessName);

		// Regarding System Idle Process: It has 1 threads in Task Manager 
		// and PVIEW (Process Viewer) but in our app it has 0 threads.

		if(p[i]->Id==0)	// Is this the "System Idle Process"?
		{			
			pProcess->InsertItem(i,"Idle Process (System)");
			pProcess->SetItemText(i,3,"(None)");
		}
		else
		{
			sprintf(s,"%s.exe",lp);
			pProcess->InsertItem(i,s);

			// column 3 is updated here because System Idle process has no modules
			// and will be set as (None) - See 'if' part above.
			try{
				sprintf(s,"%d",p[i]->Modules->Count);
			}
			catch(...){
				sprintf(s,"**");
			}
			pProcess->SetItemText(i,3,s);
		}

		sprintf(s,"%d",p[i]->Id);
		pProcess->SetItemText(i,1,s);

		sprintf(s,"%d",p[i]->Threads->Count);
		pProcess->SetItemText(i,2,s);

		sprintf(s,"%d",p[i]->HandleCount );
		pProcess->SetItemText(i,4,s);

		System::TimeSpan ts=p[i]->TotalProcessorTime;
		sprintf(s,"%02d:%02d:%02d",ts.Hours,ts.Minutes,ts.Seconds);
		pProcess->SetItemText(i,5,s);

		lp=FromMCtoUCStr(p[i]->MainWindowTitle);
		pProcess->SetItemText(i,6, (*lp) ? lp : "*");	// Show title if exists if not show '*'
	}

	CString ss;
	ss.Format("Processes: %d",n);

	SetDlgItemText(IDC_COUNT,ss);

	// Disable 'Kill Process' and 'Close Window'
	GetDlgItem(IDCLOSE)->EnableWindow(false);
	GetDlgItem(IDKILL)->EnableWindow(false);

	// Aslo clears these items
	pModules->DeleteAllItems();
	pThreads->DeleteAllItems();
}

void CProcessSpectatorDlg::OnBnClickedKill()
{
	int nSel=pProcess->GetSelectionMark()	;
	/*if(nSel==-1)
	{
		AfxMessageBox("Please select image first.");
		pProcess->SetFocus();
		return;
	}*/

	if(AfxMessageBox(IDS_KILLWARNING,MB_YESNO)==IDYES)
	{
		try
		{
			Diagnostics::Process *g=Diagnostics::Process::GetProcessById(ProcessID[nSel]);
			g->Kill ();
		}

		catch(ArgumentException *)	// Raise when PID is invalid
		{
			AfxMessageBox("That process has already been terminated.\n(view may not be refreshed to update it)",MB_ICONEXCLAMATION);
		}
		catch(ComponentModel::Win32Exception *we) // Raised when access denies
		{
			AfxMessageBox(CString("Could not terminate the derised process: ")+FromMCtoUCStr(we->Message),MB_ICONERROR);
		}
		RefreshList();
	}
}

void CProcessSpectatorDlg::OnLvnItemchangedProcess(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	bool bIsSelected = (pNMLV->uNewState==3);

	// Enable buttons as case may be
	GetDlgItem(IDCLOSE)->EnableWindow(bIsSelected);
	GetDlgItem(IDKILL)->EnableWindow(bIsSelected);

	pModules->DeleteAllItems();
	pThreads->DeleteAllItems();

	// No process selected?
	if(!bIsSelected)
		return;
	
	using namespace Diagnostics;	// Following code extensively use this namespace
	String *s;
	CString str;
	int i;
	Process *g;

	try
	{
		g=Diagnostics::Process::GetProcessById(ProcessID[pNMLV->iItem]);
	}

	catch(ArgumentException *)	// When user clicks on terminated process (Also see "PID Problem.TXT")
	{
		pThreads->InsertItem(0,"(Terminated)");
		pModules->InsertItem(0,"(Terminated)");
		return;
	}
	
	if( ProcessID[pNMLV->iItem] != 0)	// Not Idle process
	{
		ProcessModuleCollection *mc;
		bool bOK=true;
		try	{
			mc= g->Modules;
		}
		catch(...)		// Fired when Modules property can't be accessed
		{
			pModules->InsertItem(0,"(Access Denied)");
			bOK=false;
		}

		// Have accessed Modules property
		if(bOK){

		ProcessModule *pm;
		FileVersionInfo *fv;
		int n;
	
		for(i=0	;i<mc->Count;i++)
		{
			// Assign this process module to pm
			pm=mc->Item[i];
			
			s=pm->FileName;
			n=s->LastIndexOf(L'\\') + 1;
			if(n)
				s=s->Substring(n);
			pModules->InsertItem(i,FromMCtoUCStr(s));
			
			try{
                		fv=pm->FileVersionInfo;
			}
			catch(...){
				pModules->SetItemText(i,1,"**");
				pModules->SetItemText(i,2,"**");
				pModules->SetItemText(i,3,"**");
				continue;
			}
			
			str.Format("%d.%d.%d.%d",fv->FileMajorPart,fv->FileMinorPart,fv->FileBuildPart,fv->FilePrivatePart);

			pModules->SetItemText(i,1,str); 
			str.Format("0x%x",pm->BaseAddress.ToInt32());
			pModules->SetItemText(i,2,str);
			str.Format("%.2fK",pm->ModuleMemorySize/1024.0);
			pModules->SetItemText(i,3,str);
		}}
	}

	// Not that Threads property access does not fail even if Modules
	// access fails. On your system it may fail (why? I don't know)
	ProcessThreadCollection *tc=g->Threads;
	ProcessThread *pt;
	for(i=0;i<tc->Count;i++)
	{
		pt=tc->Item[i];
		str.Format("%d",pt->Id);
		pThreads->InsertItem(i,str);

		str.Format("%d",pt->BasePriority);		// Base priority (Calculated by OS)
		pThreads->SetItemText(i,1,str);

		System::TimeSpan ts=pt->TotalProcessorTime;
		str.Format("%02d:%02d:%02d",ts.Hours,ts.Minutes,ts.Seconds);
		pThreads->SetItemText(i,2,str);

		str.Format("0x%x",pt->StartAddress.ToInt32());		// Start/Base address of thread
		pThreads->SetItemText(i,3,str);
	}
}
